

/* 
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


#if defined(_WIN32) || defined(__GNUC__)
	#include <iostream>
	using namespace std ;
#else
	#include <iostream.h>
#endif
#ifdef _WIN32
#include <windows.h> 
#include <winbase.h>
#else
#include <time.h>
#include <unistd.h>
#endif
#include "tcpsck.h"
#include "UmtsServer.h"

#ifdef _WIN32 
#define doSomeStuff(a) Sleep(a*1000); 
#else 
#define doSomeStuff(a) sleep(a);
#endif 

#define TCPIP_PORT_NUMBER 1810

void UmtsServer::handle( tcpsck_return_t ret )
{
 if (ret==TCPSCK_ERROR)
  {
   cerr <<"BaseStation:" << tcpsck_get_error_message(tcpsck_get_last_error()) << endl;
   exit(1);
  }
}

UmtsServer::UmtsServer(int size):
List(size)
{
 int ret;
 NetworkNode *node1= new NetworkNode("Jupiter","128.64.32.1");
 NetworkNode *node2= new NetworkNode("Saturn","128.64.32.2"); 
 NetworkNode *node3= new NetworkNode("Uranus","128.64.32.3"); 
// Tutorial info
// The following code line causes a memory leak
 NetworkNode *node4= new NetworkNode("Neptune","128.64.32.4"); 
// Tutorial info
// To remove the memory error (ABWL)
// Change in the following line the argument from 3 to 4  
 networkNodes = new List(3);
 networkNodes->addItem(node1);
 networkNodes->addItem(node2); 
 networkNodes->addItem(node3); 
 networkNodes->addItem(node4); 


 tcpsck_init(); 
 listenSocket=tcpsck_new_socket();
 ret=tcpsck_set_addr(&listenAddr,(char *)0,TCPIP_PORT_NUMBER);
 handle(ret);
 ret=tcpsck_bind_and_listen ( listenSocket, &listenAddr ); 
 handle(ret);
}

void UmtsServer::checkPowerSupply()  
{
 // dummy function to be implemented
doSomeStuff(1);
}

void UmtsServer::checkUmtsNetworkConnection()
{
// Tutorial info
// To reduce the time spent in this function 
// Comment the following line
 doSomeStuff(1); 
}

void UmtsServer::checkHardware() 
{
 checkPowerSupply();
// Tutorial info
// The following method is time consuming 
// Comment the following function ...
 checkUmtsNetworkConnection(); 
}

int UmtsServer::exec( )
{
 tcpsck_socket_handle_t sck;

 try {
 for(;;)
 {
  checkHardware();
  if (tcpsck_data_ready(listenSocket,2))
  {
   sck=tcpsck_accept(listenSocket,&listenAddr);
   handle(sck);
// Tutorial info
// The following code line causes a memory leak 
   UmtsConnection *cnx=new UmtsConnection(sck);
   addItem((void *)cnx);
  }
  if (!isEmpty())
   {
    UmtsConnection *cnx=(UmtsConnection *)getCurrent();
    if (cnx->serverShutdown)
    {
     // Tutorial info
     // the following commented line
     // causes an exception when the mobile
     // disconnects from the BaseStation
     // return(0);
    }
// Tutorial info
// the following function call causes a memory leak
// Have a look at the method UmtsConnection::processMessages
// down one level into the call stack of report
    cnx->processMessages();
    goNext();
   }
  }
  return(0); 
 }
 catch (LostConnection &e)
 {
  handle(e.id());
  return(1);
 }
}

UmtsServer::~UmtsServer( )
{
 tcpsck_end(); 
}

