

/* 
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */



package baseStation;

import java.util.Vector;

public class NetworkLoadMonitor extends Thread
{
	private LogServer _logServer;
	private int num;
	private Vector _channels;

	public NetworkLoadMonitor()
	{
		super("Network Load Monitor");
		_channels=new Vector();
	}

	public void setLogServer(LogServer logServer)
	{
		_logServer=logServer;
	}

	public void oneCnxStarted()
	{
		num++;
	}

	public void shutdown()
	{
			_logServer.log("Panic! shutting down");

	}

	public void oneCnxTerminated()
	{
		num--;
		// No more connected phone, end of the demo
		if (num==0) 
		{
			shutdown();
			System.exit(0);
		}
	}

	private void GetChannels()
	{
		// Tutorial info
		// the method is allocating memory that is not completely collected
		// Have a look at the method ReleaseChannels below
		int i;
		for (i=0;i<=10;i++)
		{
			_channels.add(new byte[16]);
		}
	}

	private void ReleaseChannels()
	{
		// Tutorial info
		// the method should remove one more element from the _channels Vector
		// Have a look below
		int i;
		// Tutorial info
		// the right code should be:
		// for (i=0;i<=10;i++)
		// instead of the following line
		for (i=0;i<10;i++)
		{
			_channels.removeElementAt(0);
		}
	}

	public void run()
	{
		while (true)
		{
			_logServer.log("Network ok");
			GetChannels();
			ReleaseChannels();
			try 
			{
				sleep(1000);
			}
			catch (Exception e)
			{
				System.out.println(e);
			}
		}
	}
}

