

/* 
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */



package baseStation;

import java.io.*;
import java.net.*;

public class UmtsServer
{
	private static int port = 1810;
	private ServerSocket _serverSocket;
	private HardwareMonitor _hwMonitor;
	private NetworkLoadMonitor _netLoadMonitor;
	private LogServer _logServer;

	public UmtsServer()
	{
		_logServer = new LogServer();
		_hwMonitor = new HardwareMonitor();
		_hwMonitor.setLogServer(_logServer);
		StringBuffer s= new StringBuffer();
		_netLoadMonitor = new NetworkLoadMonitor();
		_netLoadMonitor.setLogServer(_logServer);

		try 
		{
	     	_serverSocket = new ServerSocket(port);
	     	System.out.println("BaseStation: waiting for phone to connect on port " + 
			       _serverSocket.getLocalPort());
	    }
	    catch (IOException e) 
	    {
		   	System.out.println(e);
		}
	}
	
	public void start( )
	{
		int numStarted=0;
		int numClosed=0;
		_logServer.start();
		_hwMonitor.start(); 
		_netLoadMonitor.start();
		try
		{
	    	while(true) 
	    	{
				Socket socket = _serverSocket.accept();
				System.out.println("New connection accepted " +
				    socket.getInetAddress() +
			 	  ":" + socket.getPort());
				numStarted++;
				UmtsConnection cnx=new UmtsConnection(numStarted);
				cnx.setSocket(socket);
				cnx.setNetworkLoadMonitor(_netLoadMonitor);
				new Thread(cnx,"Connexion #"+Integer.toString(numStarted)).start();
				_logServer.log("New Connexion #"+Integer.toString(numStarted));
			}
		}
		catch (IOException e) 
		{
		   	System.out.println(e);
		}
	}
}
