

/* 
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


/*
 * @(#)About.java	02/02/18
 * (C) 2003 Rational Software Corporation. All Rights Reserved.  
 */

package example;

import javax.microedition.lcdui.*;

/**
 * Typical about box with a string and an image.
 * In this case the Rational Test RealTime copyright and logo.
 */

public class About {

    private static String copyright =
      "(C) 2003 Rational Software Corporation. All Rights Reserved.\n"
    + "Rational, the Rational logo are registered trademarks of"
    + "Rational Software Corporation.\n"
    + "\n"
    + "The placing of the copyright notices on Rational source code is not"
    + "intended to mean that they are published works, but are included in the"
    + "event of inadvertent publication. The source code of Rational contains"
    + "trade secrets and other valuable confidential information of Rational"
    + "Software Corporation. Rational Software Corporation and its licensors"
    + "retain ownership to Rational Products in both source and object code"
    + "format, and related documentation and all rights therein including"
    + "copyrights, patents and trade secrets.\n"
    + "\n"
    + "\n"
    + "U.S. Government Rights\n"
    + "\n"
    + "Use, duplication, or disclosure by the U.S. Government is subject to"
    + "restrictions set forth in the applicable Rational License Agreement"
    + "and in DFARS 227.7202-1(a) and 227.7202-3(a) (1995), DFARS"
    + "252.227-7013(c)(1)(ii)(Oct 1988), FAR 12.212(a) 1995, FAR 52.227-19,"
    + "or FAR 52.227-14, as applicable.\n"
    + "\n"
    + "Unless otherwise agreed to in writing, use of Rational products is"
    + "governed by the Rational Product License Agreement provided with"
    + "the product.\n";

    private Displayable previous; // the previous screen to go back to

    private About() {}		// no instances

    /**
     * Put up the About box and when the use click ok return
     * to the previous screen.
     */
    public static void showAbout(Display display) {

	Alert alert = new Alert("About TestRT");
	alert.setTimeout(Alert.FOREVER);

	if (display.numColors() > 2) {
	    String icon = (display.isColor()) ?
		"/icons/atlogo-8.png" : "/icons/atlogo-bw.png";

	    try {
	        Image image = Image.createImage(icon);
		alert.setImage(image);
	    } catch (java.io.IOException x) {
		// just don't append the image.
	    }
	}
	// Add the copyright
	alert.setString(copyright);

	display.setCurrent(alert);
    }

}
