

/* 
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


/*
 * @(#)Board.java	02/02/18
 * (C) 2003 Rational Software Corporation. All Rights Reserved.  
 */

package example.eurodollar;

import example.About;
import javax.microedition.lcdui.*;
import javax.microedition.midlet.MIDlet;

public class Board extends Canvas implements CommandListener {

MIDlet midlet;
Display dpy;
Options options;

// this string must be exactly 15 characters long
//String url = "http://fr.finance.yahoo.com/d/quotes.txt?s=EURUSD=X&f=sl1d1t1c1ohgv&e=.csv"; 
String url = "http://finance.yahoo.com/d/quotes.csv?s=^XEU&f=sl1d1t1c1ohgv&e=.csv";
Font font;

// commands
static final int CMD_ABOUT	= 0;
static final int CMD_EXIT	= 1;
static final int CMD_OPTIONS	= 2;
static final int CMD_UPDATE	= 3;
static final int CMD_ZLAST	= 4;	// must be ze last, of course
Command cmd[];

void D(String s) { System.out.println(s); }


    class BoardCommand extends Command {
	int tag;

	BoardCommand(String label, int type, int pri, int tag_) {
		super(label, type, pri);
		tag = tag_;
	}
    }

public Board(MIDlet midlet_) {

	int i;

	// "global" variables

	midlet = midlet_;
	dpy = Display.getDisplay(midlet);

	font = Font.getFont(Font.FACE_SYSTEM,
	    Font.STYLE_PLAIN, Font.SIZE_MEDIUM);

	// set up commands

	cmd = new Command[CMD_ZLAST];

	cmd[CMD_ABOUT] =
	    new BoardCommand("About", Command.HELP, 4, CMD_ABOUT);

	cmd[CMD_EXIT] =
	    new BoardCommand("Exit", Command.EXIT, 3, CMD_EXIT);

	cmd[CMD_OPTIONS] =
	    new BoardCommand("Options", Command.SCREEN, 2, CMD_OPTIONS);
	
	cmd[CMD_UPDATE] =
	    new BoardCommand("Update", Command.SCREEN, 1, CMD_UPDATE);
	
	// set up the listener

	setCommandListener(this);

	// set up options screen

	options = new Options(dpy, this);

        addCommand(cmd[CMD_ABOUT]);
        addCommand(cmd[CMD_EXIT]);
        addCommand(cmd[CMD_OPTIONS]);
        addCommand(cmd[CMD_UPDATE]);

        retrieveUrl();
	dpy.setCurrent(this);
}


public void commandAction(Command c, Displayable d) {
	switch (((BoardCommand) c).tag) {
	    case CMD_ABOUT:
		About.showAbout(Display.getDisplay(midlet));
		break;
	    case CMD_EXIT:
		midlet.notifyDestroyed();
		break;
	    case CMD_OPTIONS:
		dpy.setCurrent(options);
		break;
	    case CMD_UPDATE:
                retrieveUrl();
		break;
	}
}


public void showNotify() {
	// System.out.println("Board: showNotify");
}

public void hideNotify() {
	// System.out.println("Board: hideNotify");
}

public void paint(Graphics g) {
	g.setColor(0xFFFFFF);
	g.fillRect(0, 0, getWidth(), getHeight());
	    
	g.setColor(0x404040);
        int y = font.getHeight() + 3;
	g.drawString(date,
                     getWidth() / 2,
                     y,
                     Graphics.BOTTOM|Graphics.HCENTER);
        y += font.getHeight() + 1;
	g.drawString(hour,
                     getWidth() / 2,
                     y,
                     Graphics.BOTTOM|Graphics.HCENTER);
        y += font.getHeight() + 1;
	g.drawString("1 EURO =",
                     getWidth() / 2,
                     y,
                     Graphics.BOTTOM|Graphics.HCENTER);
        y += font.getHeight() + 1;
	g.drawString(value + " USD",
                     getWidth() / 2,
                     y,
                     Graphics.BOTTOM|Graphics.HCENTER);
}


public void keyPressed(int code) {
	int game = getGameAction(code);

	switch (game) {
	    case Canvas.UP:
		break;
	    case Canvas.DOWN:
		break;
	    case Canvas.LEFT:
		break;
	    case Canvas.RIGHT:
		break;
	    default:
		return;
	}

	//repaint();

}

private String value, date, hour;

public void retrieveUrl() {
  //TBD:
  HttpRetriever retriever = new HttpRetriever(url, midlet);
  try {
    retriever.startApp();
  } catch ( InterruptedException e ) {
    System.err.println("Transfert interrupted");
  }
//System.err.println("GOT:"+retriever.buffer);
  String s = retriever.buffer.toString();
  int p = s.indexOf ( "," );
  int p1 = s.indexOf ( ",", p+1 );
  value = s.substring ( p+1, p1 );
  int p2 = s.indexOf ( ",", p1+1 );
  date = s.substring ( p1+2, p2-1 );
  int p3 = s.indexOf ( ",", p2+1 );
  hour = s.substring ( p2+2, p3-1 );
  repaint();
}

}
