

/* 
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


/* 
 * (C) 2003 Rational Software Corporation. All Rights Reserved.  
 * 
 * file        : main.c
 *
 */

#include <stdio.h>
#include "stack.h"


static void set_message(message_t *msg,char *applname,char *userdata)
{
  static int i=0;
  msg->type=DATA;
  msg->num=++i;
  
  if (userdata)
    {   
      msg->length=strlen(userdata);
      strcpy(msg->userdata,userdata);
    }
  else
    {
      msg->length=0;
      msg->userdata[0]=0;    
    }
  
  if (applname)
   {   
     strcpy(msg->applname,applname);
   }
  else
    {
      msg->applname[0]=0;    
    }
  
}

void main()
{
  appl_id_t id;
  int j,code;
  message_t msg;
  char tmp[1024];
  
  /* Initialisation and registering of the two applications */ 
  if((code=mbx_init(&id))!=err_ok)
    {
      printf("Initialization error !!! : %d \n",code); 
      exit(-1);
    }
  strcpy(id.applname,"JUPITER");
  if((code=mbx_register(&id))!=err_ok)
    {
      printf("JUPITER registering error !!! : %d\n",code); 
      exit(-1);
    }
  strcpy(id.applname,"SATURN");
  if((code=mbx_register(&id))!=err_ok)
    {
      printf("SATURN registering error !!! : %d\n",code); 
      exit(-1);
    }
  

  
  for (j=0;j<10;j++)
    {
      init_message(&msg);  
      set_message(&msg,"SATURN","What time is it ?");
      strcpy(id.applname,"JUPITER");
      mbx_send_message( &id, &msg);
      mbx_get_message(&id,&msg,0);
      init_message(&msg);
      sprintf(tmp," It's 10h 5m %ds on JUPITER",j+1);  
      set_message(&msg,"JUPITER",tmp);
      strcpy(id.applname,"SATURN");
    
      mbx_send_message(&id, &msg);
      mbx_get_message(&id,&msg,0);
     
  }
  msg.type=SHUTDOWN;
  strcpy(msg.applname,"DUMPTRACE");
  strcpy(msg.userdata,"SHUTDOWN");
  mbx_send_message( &id, &msg);
  strcpy(id.applname,"JUPITER");
  mbx_unregister(&id); 
  strcpy(id.applname,"SATURN");
  mbx_unregister(&id); 
  mbx_end(&id);

}





