

------------------------------------------------------------------------
--
--  Licensed Materials - Property of IBM
--  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
--  IBM Rational Test RealTime
--  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
--
--  US Governement Users Restricted Rights - Use, duplication or
--  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
------------------------------------------------------------------------



with Pck_Stub;
with Text_Io;

package body Prg_Under_Tst is

    type T_Prio is access Prioritaire;

    task body Prioritaire is
	Go_On : Boolean := True;
    begin
	loop
	    exit when not Go_On;

	    select
		accept Do_Something_Useful (Param_Une : in Duration) do
		    Text_Io.Put_Line ("Ok, let's wait.");
		    delay Param_Une;
		end Do_Something_Useful; -- accept
	    or
		accept Unit_Testing_Exit_Loop do
		    Go_On := False;
		end Unit_Testing_Exit_Loop;
	    else
		Text_Io.Put_Line ("Default.");
	    end select;

	    Pck_Stub.Proc_Stubbed;
	    if Go_On then
		Text_Io.Put_Line ("Loop continues.");
	    else
		Text_Io.Put_Line ("Loop ends.");
	    end if;

	    delay Duration (5);

	end loop;

	accept Unit_Testing_Wait_Termination do
	    Text_Io.Put_Line ("Stopping Task.");
	    return;
	end Unit_Testing_Wait_Termination;

	Text_Io.Put_Line ("Exiting Task!");
    end Prioritaire;

    procedure Attol_Test is separate;

end Prg_Under_Tst;


